# WALHS.py
import sys
import itertools

roman = ['I','II','III','IV','V','VI','VII','VIII']

def genLst( rotors ):
    lst = list(  itertools.permutations( rotors ,3) )
    lesWalzs = []
    for walz in lst:
        ch = roman[int(walz[0])-1] + "," + roman[int(walz[1])-1]\
            +","+roman[int(walz[2])-1]
        lesWalzs.append( ch  )
    return lesWalzs

class LES_WALHS:
    COM  = ["D-I,D-II,D-III", "D-I,D-III,D-II", "D-II,D-I,D-III",
            "D-II,D-III,D-I", "D-III,D-I,D-II", "D-III,D-II,D-I"]
    RLW  = ["R-I,R-II,R-III", "R-I,R-III,R-II", "R-II,R-I,R-III",
            "R-II,R-III,R-I", "R-III,R-I,R-II", "R-III,R-II,R-I"]
    MIN  = ["I,II,III"      , "I,III,II"      , "II,I,III",
            "II,III,I"      , "III,I,II"      , "III,II,I"]
    def __init__(self, lst ):
        self.index = -1
        tb = lst.split(":")
        if len(tb) ==  1:
            if  lst == "COM":
                self.Walhs = LES_WALHS.COM
            elif lst == "RLW":
                self.Walhs = LES_WALHS.RLW
            elif lst == "MIN":
                self.Walhs = genLst( '123' )
            elif lst == "HEER":
                self.Walhs = genLst( '12345' )
            elif lst == "NAVY":
                self.Walhs = genLst( '12345678' )
            else:
                self.Walhs = tb
        else:
            self.Walhs = tb

    def __iter__(self):
        return self

    def __next__(self): # Python 3: def __next__(self)
        if self.index >= (len(self.Walhs)-1):
            raise StopIteration
        else:
            self.index += 1
            return self.Walhs[ self.index ]

#--------------------------------------------------
if __name__ == "__main__":
    for c in LES_WALHS( sys.argv[1]):
        print(c)
    
